// LCD@Control @LcdCtrl.h //
#ifndef LCD_CONTROL_HEADER
#define LCD_CONTROL_HEADER

#include <avr/pgmspace.h>

// RECT `ĂȂ΂ǂň񂾂`B
#ifndef DEFINED_RECT
#define DEFINED_RECT 
typedef struct{
	int left;
	int top;
	int right;
	int bottom;
}RECT;
#endif


// ****wp[֐S@ *******
uint8_t ReadLcdCmd();
uint8_t ReadLcdData();
void WriteLcdCmd(uint8_t ch);
void WriteLcdData(uint8_t ch);
void DisplayOn(uint8_t on);
void SetStartLine(int line);
void SetPage(int page);
void SetColumn(int column);
int ReadLcdPage(int column,int page,uint8_t data[],int num);
void WriteLcdPageRam(int column,int page
	,const uint8_t data[],int num);
void WriteLcdPagePrgm(int column,int page
	,const prog_uchar dat[],int num);// dat͒ډ摜̐擪w

void FillChipMemory(uint8_t pattern);
int WritePageRectRam(int left,int topPage
	,int right,int bottomPage,const uint8_t data[]);
int WritePageRectPrgm(int left,int top
	,int right,int bottom,const prog_uchar data[]);
int ReadPageRectRam(int left,int topPage
	,int right,int bottomPage,uint8_t data[]);
// **** wp[֐S@܂ ******

// ****LCD֐S@ ******
void InitPort();	// |[g
void InitLcd();		// LCD
// ****LCD֐S@ ******

// ****KWFbgߍ݊֐S@ *******

/*********************************************************
   ʃf[^[vOkbcɏ
   src[]͂kbcCAEgōwb_[t
   ߂FŔO
**********************************************************/
int WriteLcdFromPrgm(int left,int top,const prog_uchar src[]);
/*********************************************************
   ̊֐Ƌ@\͓ňʒuw肪RECT
**********************************************************/
int WriteLcdFromPrgmR(RECT rect,const prog_uchar src[]);

/*********************************************************
   q`l̉ʃf[^[kbcɏ
   src[]̓wb_[Ȃ̐摜
   ߂FŔO
**********************************************************/
int WriteLcdFormRam(int left,int top
	,int right,int bottom
	,const uint8_t src[]);
/*********************************************************
   ̊֐Ƌ@\͓ňʒuw肪RECT
**********************************************************/
int WriteLcdFromRamR(RECT rect,const uint8_t src[]);

/*********************************************************
   Horizontal Bar Graph  Value Range [0..1000]
   o[Ot@W͂OPOOOtXP[Œ
   
   positionF  ʒu
   LHomeF     Oō_AO͉E_
   padShapeF  OŃnb`OAOŃXvbĝ
   ߂F      ŔO
**********************************************************/
int BarGraphH(int left,int top,int right,int bottom,
	int position,uint8_t LHome,uint8_t padShape);
/**********************************************************
   ̊֐Ƌ@\͓ňʒuw肪RECT
***********************************************************/
int BarGraphHR(RECT rect,int position,uint8_t LHome,uint8_t padShape);

/***********************************************************
   Vertical Bar Graph [0..1000]
   o[Ot
   W@OPOOOtXP[
   positionF   ʒuixj
   DHomeF      Oŉ_AOŏ㌴_
   padSahape:   OŃnb`OAOŃXvbĝ
   ߂F       ŔO
************************************************************/
int BarGraphV(int left,int top,int right,int bottom,
	int position, uint8_t DHome,uint8_t padShape);
/***********************************************************
   ̊֐Ƌ@\͓ňʒuw肪RECT
************************************************************/
int BarGraphVR(RECT rect,int position, uint8_t DHome,uint8_t padShape);

/***********************************************************
   \
   
   str:     
   font:    tHg
************************************************************/
int PutStr(int left,int top,int right, int bottom
	,char *str,const prog_uchar font[]);
/***********************************************************
    ̊֐Ƌ@\͓ňʒuw肪RECT
************************************************************/
int PutStrR(RECT rect,char *str,const prog_uchar font[]);

/***********************************************************
   \@E菑iցj
   
   str:   
   font:  tHg
   ߂F OŐ
***********************************************************/
int PutStrV(int left,int top,int right, int bottom
	,char *str,const prog_uchar font[]);
/**********************************************************
   ̊֐Ƌ@\͓ňʒuw肪RECT
***********************************************************/
int PutStrVR(RECT rect,char *str,const prog_uchar font[]);

// ****KWFbgߍ݊֐S@܂ *******

#endif // LCD_CONTROL_HEADER
