/* ---------------------------------------------

	[ main.c ]

	YHY024AP C[`
	(c) 2010, By Y.Kyotani

--------------------------------------------- */

#include	<stdio.h>
#include	<string.h>
#include	<avr/io.h>
#include	<avr/pgmspace.h>
#include	<avr/interrupt.h>


#include	"lcdsub.h"
#include	"imdTimer.h"
#include	"F50_28.h"
#include	"MainScreen.h"
#include	"Alfa.h"

/* ---------------------------------------------

	C[`

--------------------------------------------- */
#define SW1	4
#define SW1ON (!(PINA&(1<<SW1)))

int main (void)	{
	uint8_t	sw1=0;

	InitTimer();
	timeStart = 0;
	sei		();
	InitLcdPort();
	LcdInit		();			// tRg[[
	DDRA &= ~(1<<SW1);
	PORTA |= (1<<SW1);		// SW1vAbv

	GCls(RGB2U16(0xFF,0xFF,0xFF));

	WriteLcdFromPrgm(0,0,mainscreen_LcdData);
	WriteLcdFromPrgmR(Alfa_rect,Alfa_LcdData);
	char str[50];
	int min,sec,sec1;
	for(;;){
		if(SW1ON && (!sw1)){
			sw1 = 1;
			if(timeStart)timeStart=0;
			else {
				if(time) time = 0;
				else timeStart=1;
			}
		}
		if(!SW1ON && (sw1)) sw1 = 0;
		min = time/6000;
		sec = (time%6000)/100;
		sec1 = (time%100);
		sprintf(str,"%02d:%02d.%02d",min,sec,sec1);
		PutStrR(Time1_rect,RGB2U16(255,128,0),RGB2U16(0,0x40,0x80),str,F50_28_Font);
		if(sec1==0)
			BargraphHR(Graph1_rect,(time/360),1,1,RGB2U16(255,255,0),RGB2U16(0,0x40,0x80));
	}
	while(1);
	return 0;
}
// End of main.c
